# Define las etapas del pipeline
stages:
  - build
  - test
  - deploy


# Etapa de construcción
build:
  stage: build
  image: node:16
  script:
    - npm install -g @angular/cli@12.0.0 # Instalamos Angular CLI de forma global
    - npm install # Instalamos las dependencias del proyecto
    - ng build --prod # Compilamos la aplicación en modo producción
  artifacts:
    paths:
      - dist/ # Especificamos la carpeta donde se generará el código compilado

# Etapa de pruebas
test:
  stage: test
  image: node:16
  script:
    - echo "Ejecutando pruebas..."

# Etapa de despliegue
deploy:
  stage: deploy
  image: mrisco/pulumi-alpine
  script:
    - aws configure set aws_access_key_id AKIAQ3EGRBFDOZ46LYWF
    - aws configure set aws_secret_access_key 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
    - aws configure set region us-east-1
    - echo "Ejecutando deploy...."
    # Implementar los archivos en el bucket
    - aws s3api put-object --bucket proyectbucket-8c51eda --key uni-demo-angular/
    - aws s3 sync ./dist/* s3://proyectbucket-8c51eda/uni-demo-angular
  only:
    - testawss3 #Definir la unica rama con la que se levantara el stage de deploy, NT:Debe ser la rama principal debido a las variables que se configuran en Git Lab